package me.parsell.glowstonewire.core;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

import me.parsell.glowstonewire.GlowstoneWire;

public class glowLootTables {
    public static JsonObject glowstonelootTable;

    public static void init(){
      if(GlowstoneWire.CONFIG.replaceGlowstoneDrop) {
        JsonObject explosion;
        JsonObject limitValues, limit;
        JsonObject bonus, parametersValues;
        JsonObject count, countValues;
        JsonArray secondItemArray;
        JsonObject secondItem;
    
        JsonObject levelsValues, silktouch;
        JsonArray enchantmentsArray;
        JsonObject enchantments, match;
        JsonArray firstItemArray;
        JsonObject firstItem;
    
        JsonArray alternativesArray;
        JsonObject alternatives;
    
        JsonArray rollsArray;
        JsonObject rolls;
    
        JsonArray lootPoolsArray;

        explosion = new JsonObject();
        explosion.addProperty("function", "minecraft:explosion_decay");

        limit = new JsonObject();
        limit.addProperty("function", "minecraft:limit_count");
        limitValues = new JsonObject();
        limitValues.addProperty("max", 4);
        limitValues.addProperty("min", 1);
        limit.add("limit", limitValues);

        bonus = new JsonObject();
        bonus.addProperty("function", "minecraft:apply_bonus");
        bonus.addProperty("enchantment", "minecraft:fortune");
        bonus.addProperty("formula", "minecraft:uniform_bonus_count");
        parametersValues = new JsonObject();
        parametersValues.addProperty("bonusMultiplier", 1);
        bonus.add("parameters", parametersValues);

        count = new JsonObject();
        count.addProperty("function", "minecraft:set_count");
        countValues = new JsonObject();
        countValues.addProperty("min", 2.0);
        countValues.addProperty("max", 4.0);
        countValues.addProperty("type", "minecraft:uniform");
        count.add("count", countValues);

        secondItemArray = new JsonArray();
        secondItemArray.add(count);
        secondItemArray.add(bonus);
        secondItemArray.add(limit);
        secondItemArray.add(explosion);

        secondItem = new JsonObject();
        secondItem.addProperty("type", "minecraft:item");
        secondItem.add("functions", secondItemArray);
        secondItem.addProperty("name", "glowstonewire:glowstone_dust");

        //

        levelsValues = new JsonObject();
        levelsValues.addProperty("min", 1);
        silktouch = new JsonObject();
        silktouch.addProperty("enchantment", "minecraft:silk_touch");
        silktouch.add("levels", levelsValues);

        enchantmentsArray = new JsonArray();
        enchantmentsArray.add(silktouch);
        enchantments = new JsonObject();
        enchantments.add("enchantments", enchantmentsArray);

        match = new JsonObject();
        match.addProperty("condition", "minecraft:match_tool");
        match.add("predicate", enchantments);

        firstItemArray = new JsonArray();
        firstItemArray.add(match);
        
        firstItem = new JsonObject();
        firstItem.addProperty("type", "minecraft:item");
        firstItem.add("conditions", firstItemArray);
        firstItem.addProperty("name", "minecraft:glowstone");

        //

        alternativesArray = new JsonArray();
        alternativesArray.add(firstItem);
        alternativesArray.add(secondItem);

        alternatives = new JsonObject();
        alternatives.addProperty("type", "minecraft:alternatives");
        alternatives.add("children", alternativesArray);

        //

        rollsArray = new JsonArray();
        rollsArray.add(alternatives);

        rolls = new JsonObject();
        rolls.addProperty("rolls", 1);
        rolls.add("entries", rollsArray);

        //

        lootPoolsArray = new JsonArray();
        lootPoolsArray.add(rolls);

        glowstonelootTable = new JsonObject();
        glowstonelootTable.addProperty("type", "minecraft:block");
        glowstonelootTable.add("pools", lootPoolsArray);
      }
    }
}
